diff --git a/tests/unit_tests/ut_expensions.sh b/tests/unit_tests/ut_expensions.sh
index d349a49..20c3409 100644
--- a/tests/unit_tests/ut_expensions.sh
+++ b/tests/unit_tests/ut_expensions.sh
@@ -33,3 +33,20 @@ echo '$HOME'
 
 echo \$HOME
 
+export A="s -la"
+l$A
+
+export A=p
+export B=w
+$A"$B"d
+"$A"'$B'd
+
+echo "ls -la <a | grep x > b"
+
+echo ok "" ok
+
+echo ok "" "" "" "" "" "" "" "" "" ok
+
+export OK="ok                   ok"
+echo $OK
+
diff --git a/tests/unit_tests/ut_heredocs.sh b/tests/unit_tests/ut_heredocs.sh
index 4191f90..69e931f 100644
--- a/tests/unit_tests/ut_heredocs.sh
+++ b/tests/unit_tests/ut_heredocs.sh
@@ -1,13 +1,5 @@
 #!/bin/bash
 
-COMMANDE='	echo "hugo"
-			cat << EOF
-			hello you
-			EOF'
-
-echo "$COMMANDE" | bash -i &>file.log
-#echo "$COMMANDE" | ./minishell &>file.log
-
 #cat << EOF
 #hello
 #EOF
diff --git a/tests/unit_tests/ut_pipes.sh b/tests/unit_tests/ut_pipes.sh
index 19d3784..cd17612 100644
--- a/tests/unit_tests/ut_pipes.sh
+++ b/tests/unit_tests/ut_pipes.sh
@@ -34,3 +34,15 @@ rm output
 
 sleep 5 | exit
 
+ls | cat
+
+cat | ls
+
+ulimit -n
+
+ls /proc/self/fd
+
+ls | ls | ls /proc/self/fd
+
+ls | ls | ls | ls | ls | ls /proc/self/fd
+
diff --git a/tests/unit_tests/ut_redirections.sh b/tests/unit_tests/ut_redirections.sh
index 96e00ee..74f3818 100644
--- a/tests/unit_tests/ut_redirections.sh
+++ b/tests/unit_tests/ut_redirections.sh
@@ -52,3 +52,49 @@ not_cmd bonjour > salut
 ls
 rm salut
 
+>testt
+ls
+
+rm testt
+>>testt
+ls
+
+rm testt
+<testt
+ls
+rm testt
+
+touch testt
+<testt
+rm testt
+
+rm testt
+<testt
+rm testt
+
+cat <a <b >c >d
+
+echo hello >a
+echo byebye >b
+cat <a <b >c >d
+cat a
+cat b
+cat c
+cat d
+rm a b c d
+
+
+cat a | < b cat | cat > c | cat
+ls
+rm a b c
+
+echo hello >a
+echo byebye >b
+echo ouf >c
+cat a | < b cat | cat > c | cat
+ls
+cat a
+cat b
+cat c
+rm a b c
+
diff --git a/tests/unit_tests/ut_vrac.sh b/tests/unit_tests/ut_vrac.sh
index b7adfe5..b6e3588 100644
--- a/tests/unit_tests/ut_vrac.sh
+++ b/tests/unit_tests/ut_vrac.sh
@@ -17,3 +17,16 @@ minishell
 
 l^Ds
 
+touch testt
+chmod 000 testt
+ls
+./testt
+rm -rf testt
+
+mkdir testt
+./testt
+pwd
+cd ../
+rm -rf testt
+
+cat < ../
